//
// Created by illyum on 8/15/2024.
//

#include "BasicLogger.h"
#include <iostream>

// Set default verbosity
LogPriority BasicLogger::verbosity = TraceP;

void BasicLogger::Log(LogPriority priority, const char *message) {
    if (priority >= verbosity) {
        switch (priority) {
            case TraceP: std::cout << "Trace: \t"; break;
            case DebugP: std::cout << "Debug: \t"; break;
            case InfoP: std::cout << "Info: \t"; break;
            case WarnP: std::cout << "Warn: \t"; break;
            case ErrorP: std::cout << "Error: \t"; break;
            case FatalP: std::cout << "Fatal: \t"; break;
        }
        std::cout << message << "\n";
    }
}

void BasicLogger::SetVerbosity(LogPriority new_priority) {
    verbosity = new_priority;
}