//
// Created by illyum on 8/16/2024.
//

#include "ColorSwatch.h"
#include <stdio.h>
#include <stdlib.h>
#include "cJSON.h"


int SaveSwatch(const char *filename, const SavedSwatch *swatch) {
    FILE *file = fopen(filename, "wb");
    if (file == NULL) {
        return 0;
    }

    fwrite(&swatch->count, sizeof(size_t), 1, file);
    fwrite(swatch->colors, sizeof(SwatchColor), swatch->count, file);

    fclose(file);
    return 1;
}

int LoadSwatch(const char *filename, SavedSwatch *swatch) {
    FILE *file = fopen(filename, "rb");
    if (file == NULL) {
        return 0;
    }

    fread(&swatch->count, sizeof(size_t), 1, file);

    swatch->colors = (SwatchColor *)malloc(swatch->count * sizeof(SwatchColor));
    if (swatch->colors == NULL) {
        fclose(file);
        return 0;
    }

    fread(swatch->colors, sizeof(SwatchColor), swatch->count, file);
    fclose(file);
    return 1;
}

void FreeSwatch(SavedSwatch *swatch) {
    free(swatch->colors);
    swatch->colors = NULL;
    swatch->count = 0;
}

SwatchColor ImVec4ToSwatchColor(const ImVec4& color) {
    SwatchColor swatchColor;
    swatchColor.r = static_cast<unsigned char>(color.x * 255.0f);
    swatchColor.g = static_cast<unsigned char>(color.y * 255.0f);
    swatchColor.b = static_cast<unsigned char>(color.z * 255.0f);
    return swatchColor;
}

ImVec4 SwatchColorToImVec4(const SwatchColor& swatchColor) {
    return {swatchColor.r / 255.0f, swatchColor.g / 255.0f, swatchColor.b / 255.0f, 1.0f};
}
