//
// Created by illyum on 8/16/2024.
//

#ifndef COLORSWATCH_H
#define COLORSWATCH_H

#include <cstdlib>
#include <string>
#include <imgui.h>


typedef struct {
    unsigned char r;
    unsigned char g;
    unsigned char b;
} SwatchColor;

typedef struct {
    std::string swatchName;
    SwatchColor *colors;
    size_t count;
} SavedSwatch;

int SaveSwatch(const char *filename, const SavedSwatch *swatch);
int LoadSwatch(const char *filename, SavedSwatch *swatch);
void FreeSwatch(SavedSwatch *swatch);

SwatchColor ImVec4ToSwatchColor(const ImVec4& color);

ImVec4 SwatchColorToImVec4(const SwatchColor& swatchColor);

#endif //COLORSWATCH_H
